import std.c.stdlib;
import std.stdio;

// Global variables

string g_exampleVariable = "Global Example Variable"; // Only, if this is necessary

void showUsageInformation() {
	writeln(); 
	writeln("Majops Skeleton Script D is the base for making new scripts in D.");
	writeln("For this Majops Skeleton Script D, an executable file has to be made first.");
	writeln("Therefore, it has to be compiled by typing:"); 
	writeln(); 
	writeln("dmd [D script file name with .d extension]");
	writeln();
	writeln("Next to that executable file, a binary .o file is made.");
	writeln(); 
	writeln("The generated executable file can be started by typing:");
	writeln(); 
	writeln("./[D script file name without any extension]");
	writeln(); 
	writeln("To generate an executable file for this Majops Skeleton Script D, you have to type:");
	writeln(); 
	writeln("dmd MajopsSkeletonScriptD.d");
	writeln();
	writeln("Next to it, the binary .o file MajopsSkeletonScriptD.o is made.");
	writeln(); 
	writeln("To start the generated executable file for this Majops Skeleton Script D, you have to type:");
	writeln(); 
	writeln("./MajopsSkeletonScriptD");
	writeln(); 
	writeln("The user has to type here what the D script can perform and does.");
	writeln();
	writeln("Way of usage:");
	writeln();
	writeln("The user has to type here how he has to work with the D script and");
	writeln("how the command line arguments are used.");
	writeln();
	writeln("Example:");
	writeln();
	writeln("dmd MajopsSkeletonScriptD.d");
	writeln("./MajopsSkeletonScriptD input1.txt input2.csv 10 output.csv");
	writeln();
	
	exit(0);
}

// From here till the main function, functions have to be programmed. 
// An example function: showHelloWorld
void showHelloWorld(string helloWorld) {
	writeln();
	writeln(helloWorld);
	writeln();
	writeln(g_exampleVariable);
	writeln();
}
        
// The last function is always the main function, in which only other functions are called.
void main(string[] args) {
	if (args.length >= 2) {
		if (args[1] == "-h" || args[1] == "--h" || args[1] == "-help" || args[1] == "--help") {
			showUsageInformation();
		}
	}
	
	string helloToUser = "Hello World!";
	
	showHelloWorld(helloToUser);
}

// Additional information:
// =======================
//
// Remarks about the Majops Skeleton Script D itself.
// Description how it works.
// Description which improvements can be done to improve the Majops Skeleton Script D itself.
//

